<#ibiztemplate>
TARGET=PSAPPDATAENTITY
</#ibiztemplate>
package ${pub.getPKGCodeName()}.${app.getPKGCodeName()?lower_case}.${de.getPSSystemModule().getCodeName()?lower_case}.domain;

import java.io.Serializable;
import java.math.BigDecimal;
import java.math.BigInteger;
import java.sql.Timestamp;
import java.util.List;
import java.util.ArrayList;

import com.fasterxml.jackson.annotation.JsonAutoDetect;
import com.fasterxml.jackson.annotation.JsonIgnore;
import com.fasterxml.jackson.annotation.JsonProperty;
import com.fasterxml.jackson.annotation.JsonFormat;

/**
 * 应用实体[${item.getLogicName()}]
 */
public class ${item.getCodeName()} implements Serializable {

	private static final long serialVersionUID = 1L;

<#if item.getAllPSAppDEFields()??>
    <#list item.getAllPSAppDEFields() as appfield>
    /**
     * ${appfield.getPSDEField().getLogicName()}
     */
     <#assign defDataType = (appfield.getPSDEField().getDataType())!"">
    <#if defDataType == "DATETIME" || (defDataType=='PICKUPDATA' && srfdatatype(appfield.getPSDEField().getStdDataType())== "DATETIME" && appfield.getPSDEField().getValueFormat()=="%1$tY-%1$tm-%1$td %1$tH:%1$tM:%1$tS")>
    @JsonFormat(pattern="yyyy-MM-dd HH:mm:ss", locale = "zh" , timezone="GMT+8")
    <#elseif defDataType == "DATE" || (defDataType=='PICKUPDATA' && srfdatatype(appfield.getPSDEField().getStdDataType())== "DATETIME" && appfield.getPSDEField().getValueFormat()=="%1$tY-%1$tm-%1$td")>
    @JsonFormat(pattern="yyyy-MM-dd", locale = "zh" , timezone="GMT+8")
    <#elseif defDataType == "TIME" || (defDataType=='PICKUPDATA' && srfdatatype(appfield.getPSDEField().getStdDataType())== "DATETIME" && appfield.getPSDEField().getValueFormat()=="%1$tH:%1$tM:%1$tS")>
    @JsonFormat(pattern="HH:mm", locale = "zh" , timezone="GMT+8")
    </#if> 
    private ${srfjavatype(appfield.getStdDataType())} ${appfield.getCodeName()?uncap_first};

    @JsonIgnore
    private boolean ${appfield.getCodeName()?uncap_first}DirtyFlag;
    
    </#list>

    <#list item.getAllPSAppDEFields() as appfield>
    /**
     * 获取 [${appfield.getPSDEField().getLogicName()}]
     */
    @JsonProperty("${appfield.getCodeName()?lower_case}")
    public ${srfjavatype(appfield.getStdDataType())} get${appfield.getCodeName()?cap_first}(){
        return this.${appfield.getCodeName()?uncap_first} ;
    }

    /**
     * 设置 [${appfield.getPSDEField().getLogicName()}]
     */
    @JsonProperty("${appfield.getCodeName()?lower_case}")
    public void set${appfield.getCodeName()?cap_first}(${srfjavatype(appfield.getStdDataType())}  ${appfield.getCodeName()?uncap_first}){
        this.${appfield.getCodeName()?uncap_first} = ${appfield.getCodeName()?uncap_first} ;
        this.${appfield.getCodeName()?uncap_first}DirtyFlag = true ;
    }

    /**
     * 获取 [${appfield.getPSDEField().getLogicName()}]脏标记
     */
    @JsonIgnore
    public boolean get${appfield.getCodeName()?cap_first}DirtyFlag(){
        return this.${appfield.getCodeName()?uncap_first}DirtyFlag ;
    }

    </#list>
</#if>


<#comment>嵌套对象</#comment>
<#if item.getMajorPSAppDERSs()?? >
    <#list item.getMajorPSAppDERSs() as appder>
    <#assign subs = srfpluralize(appder.getMinorPSAppDataEntity().getCodeName())?lower_case >
                                    <#--  <#if appder.getParentFilter()?? >
                                        <#assign subs = appder.getParentFilter()?uncap_first >
                                    <#else>
                                        <#if appder.getPSDER1N()??>
                                        <#assign subs = appder.getPSDER1N().getCodeName()?uncap_first >
                                        </#if>
                                    </#if>  -->
	private List <${pub.getPKGCodeName()}.${app.getPKGCodeName()?lower_case}.${appder.getMinorPSAppDataEntity().getPSDataEntity().getPSSystemModule().getCodeName()?lower_case}.domain.${appder.getMinorPSAppDataEntity().getCodeName()}> ${subs} = new ArrayList<${pub.getPKGCodeName()}.${app.getPKGCodeName()?lower_case}.${appder.getMinorPSAppDataEntity().getPSDataEntity().getPSSystemModule().getCodeName()?lower_case}.domain.${appder.getMinorPSAppDataEntity().getCodeName()}>() ;

    public List<${pub.getPKGCodeName()}.${app.getPKGCodeName()?lower_case}.${appder.getMinorPSAppDataEntity().getPSDataEntity().getPSSystemModule().getCodeName()?lower_case}.domain.${appder.getMinorPSAppDataEntity().getCodeName()}> get${subs?cap_first}(){
        return ${subs} ;
    }

    public void set${subs?cap_first}(List <${pub.getPKGCodeName()}.${app.getPKGCodeName()?lower_case}.${appder.getMinorPSAppDataEntity().getPSDataEntity().getPSSystemModule().getCodeName()?lower_case}.domain.${appder.getMinorPSAppDataEntity().getCodeName()}> ${subs}){
        this.${subs} = ${subs} ;
    }

    </#list>
</#if>
}
