<#ibiztemplate>
TARGET=PSAPPDATAENTITY
</#ibiztemplate>
<#assign isCurWFDE = false>
<#if app.getAppMode()?? && app.getAppMode() == "WFAPP" && app.getAllPSAppWFs()??>
    <#list app.getAllPSAppWFs() as appwf>
        <#if appwf.getPSWorkflow().getWFProxyMode() == 3 && appwf.getPSWorkflow().getPSWFDEs()??>
            <#list appwf.getPSWorkflow().getPSWFDEs() as wfde>
                <#if wfde.getWFProxyMode() == 2 && wfde.getPSDataEntity().getId() == de.getId()>
                    <#assign isCurWFDE = true>
                    <#break>
                </#if>
            </#list>
            <#if isCurWFDE>
                <#break>
            </#if>
        </#if>
    </#list>
</#if>
<#assign isClientWFDE = false>
<#if de.hasPSDEWF() && de.getAllPSDEWFs()??>
    <#list de.getAllPSDEWFs() as wfde>
        <#if wfde.getWFProxyMode() == 1 >
            <#assign isClientWFDE = true>
            <#break>
        </#if>
    </#list>
</#if>
<#assign keyCNLC = "_id">
<#assign deapi = item.getPSDEServiceAPI()>
<#assign itemCodeName = item.getCodeName()>
<#assign itemCodeNameLC = itemCodeName?lower_case>
<#assign itemSysApiCodeName = deapi.getPSSysServiceAPI().getCodeName()>
<#assign itemSysApiCodeNameLC = deapi.getPSSysServiceAPI().getCodeName()?lower_case>
package ${pub.getPKGCodeName()}.${app.getPKGCodeName()?lower_case}.${de.getPSSystemModule().codeName?lower_case}.service;

import java.util.ArrayList;
import java.util.List;

import lombok.extern.slf4j.Slf4j;
import com.alibaba.fastjson.JSONObject;

import feign.Client;
import feign.Contract;
import feign.Feign;
import feign.codec.Decoder;
import feign.codec.Encoder;

import org.springframework.util.DigestUtils;
import org.springframework.data.domain.Page;
import org.springframework.data.domain.Pageable;
import org.springframework.security.core.Authentication;
import org.springframework.security.core.context.SecurityContextHolder;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.cloud.openfeign.ribbon.LoadBalancerFeignClient;
import org.springframework.stereotype.Service;

import ${pub.getPKGCodeName()}.util.feign.suport.SearchContextFeignEncode;
import ${pub.getPKGCodeName()}.${app.getPKGCodeName()?lower_case}.${de.getPSSystemModule().codeName?lower_case}.domain.${item.getCodeName()};
import ${pub.getPKGCodeName()}.${app.getPKGCodeName()?lower_case}.${de.getPSSystemModule().codeName?lower_case}.filter.*;
import ${pub.getPKGCodeName()}.${app.getPKGCodeName()?lower_case}.${de.getPSSystemModule().codeName?lower_case}.feign.${item.getCodeName()}FeignClient;
import ${pub.getPKGCodeName()}.${app.getPKGCodeName()?lower_case}.${app.getPKGCodeName()}Application.${itemSysApiCodeName}ClientProperties;
import ${pub.getPKGCodeName()}.util.feign.FeignRequestInterceptor;
<#if isCurWFDE || isClientWFDE>
import ${pub.getPKGCodeName()}.util.config.UniWFClientProperties;
import ${pub.getPKGCodeName()}.util.feign.UniWFFeignClient;
import ${pub.getPKGCodeName()}.util.config.SysInfoProperties;
import ${pub.getPKGCodeName()}.util.domain.*;
    <#if !isClientWFDE>
import ${pub.getPKGCodeName()}.util.helper.SpringContextHolder;
import ${pub.getPKGCodeName()}.util.security.userdetail.LoginUser;
import java.lang.reflect.Method;
import ${pub.getPKGCodeName()}.util.config.WFActivitiEngineClientProperties;
import ${pub.getPKGCodeName()}.util.feign.WFEngineFeignClient;
    </#if>
</#if>
import ${pub.getPKGCodeName()}.util.log.IBIZLog;

@Slf4j
@IBIZLog
@Service
public class ${item.getCodeName()}Service {

    ${item.getCodeName()}FeignClient client;
<#if isCurWFDE || isClientWFDE>
    @Autowired
    SysInfoProperties sysInfoProperties;

    UniWFClientProperties uniWFClientProperties;

    <#if !isClientWFDE>
    WFActivitiEngineClientProperties wfActivitiEngineClientProperties;

    WFEngineFeignClient wfActivitiEngineFeignClient;

    </#if>
    UniWFFeignClient uniWFFeignClient;
</#if>

    @Autowired
    public ${item.getCodeName()}Service(Decoder decoder, Encoder encoder, Client client, Contract contract, FeignRequestInterceptor feignRequestInterceptor,
                                    ${itemSysApiCodeName}ClientProperties ${itemSysApiCodeNameLC}ClientProperties<#if isCurWFDE || isClientWFDE>, UniWFClientProperties uniWFClientProperties<#if !isClientWFDE>, WFActivitiEngineClientProperties wfActivitiEngineClientProperties</#if></#if>) {
        if (${itemSysApiCodeNameLC}ClientProperties.getServiceId()!=null) {
    		Feign.Builder nameBuilder = Feign.builder()
                    .client(client)
                    .encoder(new SearchContextFeignEncode(encoder))
                    .decoder(decoder)
                    .contract(contract)
                    .requestInterceptor(feignRequestInterceptor)
                    ;
        	this.client = nameBuilder.target(${item.getCodeName()}FeignClient.class,"http://" + ${itemSysApiCodeNameLC}ClientProperties.getServiceId() + "/") ;
		} else if (${itemSysApiCodeNameLC}ClientProperties.getServiceUrl()!=null) {
			if (client instanceof LoadBalancerFeignClient) {
				client = ((LoadBalancerFeignClient) client).getDelegate();
			}
			Feign.Builder nameBuilder = Feign.builder()
                    .client(client)
                    .encoder(new SearchContextFeignEncode(encoder))
                    .decoder(decoder)
                    .contract(contract)
                    .requestInterceptor(feignRequestInterceptor)
                    ;
        	this.client = nameBuilder.target(${item.getCodeName()}FeignClient.class, "http://" + ${itemSysApiCodeNameLC}ClientProperties.getServiceUrl() + "/") ;
		}
<#if isCurWFDE || isClientWFDE>
        this.uniWFClientProperties = uniWFClientProperties;
		if (uniWFClientProperties.getServiceId()!=null) {
    		Feign.Builder nameBuilder = Feign.builder()
                    .client(client)
                    .encoder(encoder)
                    .decoder(decoder)
                    .contract(contract)
                    .requestInterceptor(feignRequestInterceptor)
                    ;
        	this.uniWFFeignClient = nameBuilder.target(UniWFFeignClient.class,"http://" + uniWFClientProperties.getServiceId() + "/") ;
		} else if (uniWFClientProperties.getServiceUrl()!=null) {
			if (client instanceof LoadBalancerFeignClient) {
				client = ((LoadBalancerFeignClient) client).getDelegate();
			}
			Feign.Builder nameBuilder = Feign.builder()
                    .client(client)
                    .encoder(encoder)
                    .decoder(decoder)
                    .contract(contract)
                    .requestInterceptor(feignRequestInterceptor)
                    ;
        	this.uniWFFeignClient = nameBuilder.target(UniWFFeignClient.class, "http://" + uniWFClientProperties.getServiceUrl() + "/") ;
		}
    <#if !isClientWFDE>
        this.wfActivitiEngineClientProperties = wfActivitiEngineClientProperties;
		if (wfActivitiEngineClientProperties.getServiceId()!=null) {
    		Feign.Builder nameBuilder = Feign.builder()
                    .client(client)
                    .encoder(encoder)
                    .decoder(decoder)
                    .contract(contract)
                    .requestInterceptor(feignRequestInterceptor)
                    ;
        	this.wfActivitiEngineFeignClient = nameBuilder.target(WFEngineFeignClient.class,"http://" + wfActivitiEngineClientProperties.getServiceId() + "/") ;
		} else if (wfActivitiEngineClientProperties.getServiceUrl()!=null) {
			if (client instanceof LoadBalancerFeignClient) {
				client = ((LoadBalancerFeignClient) client).getDelegate();
			}
			Feign.Builder nameBuilder = Feign.builder()
                    .client(client)
                    .encoder(encoder)
                    .decoder(decoder)
                    .contract(contract)
                    .requestInterceptor(feignRequestInterceptor)
                    ;
        	this.wfActivitiEngineFeignClient = nameBuilder.target(WFEngineFeignClient.class, "http://" + wfActivitiEngineClientProperties.getServiceUrl() + "/") ;
		}
    </#if>
</#if>
    }

<#--  主实体  start -->
<#if item.isMajor()>
<#assign parentPath = ""  >
<#assign selfPath="/" + srfpluralize(itemCodeNameLC) >
<#assign parentParams = "">
<#assign parentParams2 = "">
<#assign parentParams3 = "">
<#assign idParams = "">
<#assign idParams2 = "">
<#assign idParams3 = "">
<#assign etParams = "">
<#assign etParams2 = "">
<#assign etParams3 = "">
<#assign id_etParams = "">
<#assign id_etParams2 = "">
<#assign id_etParams3 = "">
<#assign etParams = etParams + "@RequestBody " + itemCodeName + " " + itemCodeNameLC + "">
<#assign etParams2 = etParams2 +  itemCodeName + " " + itemCodeNameLC + "">
<#assign etParams3 = etParams3 +  itemCodeNameLC + "">
<#assign idParams = idParams + "@PathVariable(\"" + itemCodeNameLC + keyCNLC + "\") " + srfjavatype(de.getKeyPSDEField().stdDataType) + " " + itemCodeNameLC + keyCNLC >
<#assign idParams2 = idParams2 + " " + srfjavatype(de.getKeyPSDEField().stdDataType) + " " + itemCodeNameLC + keyCNLC >
<#assign idParams3 = idParams3 + " " + itemCodeNameLC + keyCNLC >
<#assign id_etParams = id_etParams + "@PathVariable(\"" + itemCodeNameLC + keyCNLC + "\") " + srfjavatype(de.getKeyPSDEField().stdDataType) + " " + itemCodeNameLC + keyCNLC + ", @RequestBody " + itemCodeName + " " + itemCodeNameLC + "" >
<#assign id_etParams2 = id_etParams2 + "" + srfjavatype(de.getKeyPSDEField().stdDataType) + " " + itemCodeNameLC + keyCNLC + ", " + itemCodeName + " " + itemCodeNameLC + "" >
<#assign id_etParams3 = id_etParams3 + "" + itemCodeNameLC + keyCNLC + ", " + itemCodeNameLC + "" >
<#assign fullPath = parentPath + selfPath>
<#if item.getAllPSAppDEMethods()??>
    <#list item.getAllPSAppDEMethods() as appMethod>
    <#if appMethod.getPSDEServiceAPIMethod()??>
        <#if appMethod.getMethodType()=='DEACTION'>
            <#assign appMethodCodeName = appMethod.getCodeName()>
            <#assign deaction = appMethod.getPSDEServiceAPIMethod().getPSDEAction()>
            <#assign deactionName = deaction.getName()>
            <#assign deactionCodeName = deaction.getCodeName()>
            <#if deaction.codeName == 'Create'>
	public ${itemCodeName} ${appMethodCodeName?uncap_first}(${etParams2}) {
        return client.${deactionCodeName?uncap_first}(${etParams3});
    }

            <#elseif deaction.codeName == 'Update'>
    public ${itemCodeName} ${appMethodCodeName?uncap_first}(${id_etParams2}) {
        return client.${deactionCodeName?uncap_first}(${id_etParams3});
    }

            <#elseif deaction.codeName == 'Get'>
    public ${itemCodeName} ${appMethodCodeName?uncap_first}(${idParams2}) {
        return client.${deactionCodeName?uncap_first}(${idParams3});
    }

            <#elseif deaction.codeName == 'Remove'>
    public boolean ${appMethodCodeName?uncap_first}(${idParams2}) {
        return client.${deactionCodeName?uncap_first}(${idParams3});
    }

           <#elseif deaction.codeName == 'CheckKey'>
    public boolean ${appMethodCodeName?uncap_first}(${etParams2}) {
        return client.${deactionCodeName?uncap_first}(${etParams3});
    }

            <#else>
    public ${itemCodeName} ${appMethodCodeName?uncap_first}(${id_etParams2}) {
        return client.${deactionCodeName?uncap_first}(${id_etParams3});
    }

            </#if>
        <#elseif appMethod.getMethodType()=='FETCH'>
        <#assign deds = appMethod.getPSDEDataSet()>
	public Page<${itemCodeName}> fetch<#if (deds.getName()=='DEFAULT')>${deds.getCodeName()}<#else>${deds.getCodeName()}</#if>(<#if parentParams != "">${parentParams2} , </#if>${itemCodeName}SearchContext searchContext) {
        return client.fetch<#if (deds.getName()=='DEFAULT')>${deds.getCodeName()}<#else>${deds.getCodeName()}</#if>(<#if parentParams != "">${parentParams3} , </#if>searchContext);
    }

        </#if>
    </#if>
    </#list>
</#if>
</#if>
<#--  主实体  end -->

<#--  关系接口  start  -->
<#if item.getPSAppDERSPathCount() gt 0>
  <#list 0..1000 as x>
    <#if x gte item.getPSAppDERSPathCount()>
      <#break>
    <#else>
    <#assign parentPath = ""  >
<#assign selfPath="/" + srfpluralize(itemCodeNameLC) >
<#assign parentParams = "">
<#assign byParams = "By">
<#assign parentParams2 = "">
<#assign parentParams3 = "">
<#assign idParams = "">
<#assign idParams2 = "">
<#assign idParams3 = "">
<#assign etParams = "">
<#assign etParams2 = "">
<#assign etParams3 = "">
<#assign id_etParams = "">
<#assign id_etParams2 = "">
<#assign id_etParams3 = "">
      <#list item.getPSAppDERSPath(x) as rs>

<#assign rsMainAppDe = rs.getMajorPSAppDataEntity()>
                <#assign rsMainDe = rsMainAppDe.getPSDataEntity()>
                <#assign rsMainAppDeCN = rsMainAppDe.codeName >
                <#assign rsMainAppDeCNLC = rsMainAppDeCN?lower_case >
                <#assign rsMainDePKCN = rsMainDe.getKeyPSDEField().codeName >
                <#assign rsMainDePKCNLC = rsMainDePKCN?lower_case >
                <#assign rsMainDePKDataType = rsMainDe.getKeyPSDEField().stdDataType >
                <#assign parentPath += "/" + srfpluralize(rsMainAppDeCNLC)?lower_case + "/{" + rsMainAppDeCNLC + keyCNLC + "}" >
                <#if x != 0>
                    <#assign parentParams += ", ">
                </#if>
                <#assign parentParams += "@PathVariable(\"" + rsMainAppDeCNLC + keyCNLC + "\") " + srfjavatype(rsMainDePKDataType) + " " + rsMainAppDeCNLC + keyCNLC >
                <#assign byParams += rsMainAppDeCN >
                <#assign parentParams2 += "" + srfjavatype(rsMainDePKDataType) + " " + rsMainAppDeCNLC + keyCNLC >
                <#assign parentParams3 += "" + rsMainAppDeCNLC + keyCNLC >
<#if parentParams != "" >
    <#assign idParams = parentParams + ", ">
    <#assign idParams2 = parentParams2 + ", ">
    <#assign idParams3 = parentParams3 + ", ">
    <#assign etParams = parentParams + ", ">
    <#assign etParams2 = parentParams2 + ", ">
    <#assign etParams3 = parentParams3 + ", ">
    <#assign id_etParams = parentParams + ", ">
    <#assign id_etParams2 = parentParams2 + ", ">
    <#assign id_etParams3 = parentParams3 + ", ">
</#if>
      </#list>
      <#assign etParams = etParams + "@RequestBody " + itemCodeName + " " + itemCodeNameLC + "">
<#assign etParams2 = etParams2 +  itemCodeName + " " + itemCodeNameLC + "">
<#assign etParams3 = etParams3 +  itemCodeNameLC + "">
<#assign idParams = idParams + "@PathVariable(\"" + itemCodeNameLC + keyCNLC + "\") " + srfjavatype(de.getKeyPSDEField().stdDataType) + " " + itemCodeNameLC + keyCNLC >
<#assign idParams2 = idParams2 + " " + srfjavatype(de.getKeyPSDEField().stdDataType) + " " + itemCodeNameLC + keyCNLC >
<#assign idParams3 = idParams3 + " " + itemCodeNameLC + keyCNLC >
<#assign id_etParams = id_etParams + "@PathVariable(\"" + itemCodeNameLC + keyCNLC + "\") " + srfjavatype(de.getKeyPSDEField().stdDataType) + " " + itemCodeNameLC + keyCNLC + ", @RequestBody " + itemCodeName + " " + itemCodeNameLC + "" >
<#assign id_etParams2 = id_etParams2 + "" + srfjavatype(de.getKeyPSDEField().stdDataType) + " " + itemCodeNameLC + keyCNLC + ", " + itemCodeName + " " + itemCodeNameLC + "" >
<#assign id_etParams3 = id_etParams3 + "" + itemCodeNameLC + keyCNLC + ", " + itemCodeNameLC + "" >
<#assign fullPath = parentPath + selfPath>
<#if item.getAllPSAppDEMethods()??>
    <#list item.getAllPSAppDEMethods() as appMethod>
    <#if appMethod.getPSDEServiceAPIMethod()??>
        <#if appMethod.getMethodType()=='DEACTION'>
            <#assign appMethodCodeName = appMethod.getCodeName()>
            <#assign deaction = appMethod.getPSDEAction()>
            <#assign deactionName = deaction.getName()>
            <#assign deactionCodeName = deaction.getCodeName()>
            <#if deaction.codeName == 'Create'>
	public ${itemCodeName} ${appMethodCodeName?uncap_first}${byParams}(${etParams2}) {
        return client.${deactionCodeName?uncap_first}${byParams}(${etParams3});
    }

            <#elseif deaction.codeName == 'Update'>
    public ${itemCodeName} ${appMethodCodeName?uncap_first}${byParams}(${id_etParams2}) {
        return client.${deactionCodeName?uncap_first}${byParams}(${id_etParams3});
    }

            <#elseif deaction.codeName == 'Get'>
    public ${itemCodeName} ${appMethodCodeName?uncap_first}${byParams}(${idParams2}) {
        return client.${deactionCodeName?uncap_first}${byParams}(${idParams3});
    }

            <#elseif deaction.codeName == 'Remove'>
    public boolean ${appMethodCodeName?uncap_first}${byParams}(${idParams2}) {
        return client.${deactionCodeName?uncap_first}${byParams}(${idParams3});
    }

           <#elseif deaction.codeName == 'CheckKey'>
    public boolean ${appMethodCodeName?uncap_first}${byParams}(${etParams2}) {
        return client.${deactionCodeName?uncap_first}${byParams}(${etParams3});
    }

            <#else>
    public ${itemCodeName} ${appMethodCodeName?uncap_first}${byParams}(${id_etParams2}) {
        return client.${deactionCodeName?uncap_first}${byParams}(${id_etParams3});
    }

            </#if>
        <#elseif appMethod.getMethodType()=='FETCH'>
        <#assign deds = appMethod.getPSDEDataSet()>
	public Page<${itemCodeName}> fetch<#if (deds.getName()=='DEFAULT')>${deds.getCodeName()}<#else>${deds.getCodeName()}</#if>${byParams}(<#if parentParams != "">${parentParams2} , </#if>${itemCodeName}SearchContext searchContext) {
        return client.fetch<#if (deds.getName()=='DEFAULT')>${deds.getCodeName()}<#else>${deds.getCodeName()}</#if>${byParams}(<#if parentParams != "">${parentParams3} , </#if>searchContext);
    }

        </#if>
    </#if>
    </#list>
</#if>
    </#if>
  </#list>
</#if>
<#--  关系接口  end  -->
<#assign itemPKParam = itemCodeNameLC + keyCNLC>
<#assign wfFuncParams = srfjavatype(de.getKeyPSDEField().stdDataType) + " " + itemPKParam + ", JSONObject data">
<#assign wfFuncParams2 = srfjavatype(de.getKeyPSDEField().stdDataType) + " " + itemPKParam>
<#if isCurWFDE>
    /** 工作流行为 **/

    /**
     * 开始流程【WFStart】
     */
    public boolean wfStart(${wfFuncParams}) {
        if (data == null
                || (!data.getBoolean("noET") && data.getJSONObject("wfdata") == null)
                || (data.getBoolean("noET") && (data.getString("proxymoduleid") == null || data.getString("proxydataid") == null))) {
            System.err.println("传入参数缺失");
            data.put("srfmsg", "传入参数缺失");
            return false;
        }

        String loginuserStr = null;

        // 流程数据
        WFInstance pWfinstance = null;
        ${itemCodeName} ${itemCodeNameLC} = null;
        if (data.getBoolean("noET")) {
            ${itemCodeNameLC} = new ${itemCodeName}();
            ${itemCodeNameLC}.set${de.getDefaultPSDEWF().getProxyDataPSDEField().getCodeName()?cap_first}(data.getString("proxydataid"));
            ${itemCodeNameLC}.set${de.getDefaultPSDEWF().getProxyModulePSDEField().getCodeName()?cap_first}(data.getString("proxymoduleid"));

            String pinstid = data.getString("pinstid");
            if(pinstid != null && !pinstid.isEmpty()) {
                pWfinstance = this.uniWFFeignClient.getWFInstance(pinstid);
                ${itemCodeNameLC}.set${de.getMajorPSDEField().getCodeName()?cap_first}(pWfinstance.getWfinstancename());
                <#if de.getDefaultPSDEWF().getPWFInstPSDEField()??>
                ${itemCodeNameLC}.set${de.getDefaultPSDEWF().getPWFInstPSDEField().getCodeName()?cap_first}(pinstid);
                </#if>
            }
            ${itemCodeNameLC} = this.client.create(${itemCodeNameLC});
            ${itemPKParam} = ${itemCodeNameLC}.get${de.getKeyPSDEField().getCodeName()?cap_first}();
        } else {
            JSONObject itemJo = data.getJSONObject("wfdata");
            ${itemCodeNameLC} = itemJo.toJavaObject(${itemCodeName}.class);
        }

        String proxmoduleid = ${itemCodeNameLC}.get${de.getDefaultPSDEWF().getProxyModulePSDEField().getCodeName()?cap_first}();
        String proxydataid = ${itemCodeNameLC}.get${de.getDefaultPSDEWF().getProxyDataPSDEField().getCodeName()?cap_first}();
        if (proxmoduleid == null || proxmoduleid.isEmpty() || proxydataid == null || proxydataid.isEmpty()) {
            System.err.println("流程数据异常");
            data.put("srfmsg", "流程数据异常");
            return false;
        }

        // 统一工作流申请实例
        WFInstance wfinstance = new WFInstance();
        <#assign wf = item.getPSAppWF().getPSWorkflow()>
        wfinstance.setBsdata(proxydataid);
        wfinstance.setBswfdata(${itemCodeNameLC}${keyCNLC});
        wfinstance.setPsworkflowid("${wf.getDeployId()}");
        wfinstance.setWfengineid("ACTIVITI");
        <#if item.getPSAppWF().getPSAppWFVers()??>
            <#list item.getPSAppWF().getPSAppWFVers() as wfver>
        wfinstance.setPswfversionid("${wfver.getPSWFVersion().getDeployId()}");
        wfinstance.setWfinstancename("${wfver.getName()} - " + ${itemCodeNameLC}.get${item.getMajorPSAppDEField().getCodeName()?cap_first}());
            <#break>
            </#list>
        </#if>
        wfinstance.setWfappid(sysInfoProperties.getAppid());
        wfinstance.setWorkflowid(sysInfoProperties.getDomainid());
        wfinstance.setPssystemid(sysInfoProperties.getSystemid());
        wfinstance.setProxymoduleid(proxmoduleid);

        if (pWfinstance != null) {
            if (pWfinstance.getMajorinstid() == null || pWfinstance.getMajorinstid().isEmpty()) {
                wfinstance.setMajorinstid(pWfinstance.getWfinstanceid());
            } else {
                wfinstance.setMajorinstid(pWfinstance.getMajorinstid());
            }
            wfinstance.setParentinstid(pWfinstance.getWfinstanceid());

            // 组织信息存储
            wfinstance.setOriginpersonid(pWfinstance.getOriginpersonid());
            wfinstance.setOriginpersonname(pWfinstance.getOriginpersonname());
            wfinstance.setOriginorgid(pWfinstance.getOriginorgid());
            wfinstance.setOriginorgname(pWfinstance.getOriginorgname());
            wfinstance.setOriginorgdeptid(pWfinstance.getOriginorgdeptid());
            wfinstance.setOriginorgdeptname(pWfinstance.getOriginorgdeptname());
            wfinstance.setOrgid(data.getString("orgid"));
            wfinstance.setOrgdeptid(data.getString("orgdeptid"));
            wfinstance.setWfuserid(data.getString("wfuserid"));
            wfinstance.setInstancetype(data.getString("instancetype"));

            loginuserStr = pWfinstance.getOriginpersonid();
        } else {
            // 登录用户信息
            LoginUser loginUser = SpringContextHolder.getCurLoginUser();
            if (loginUser == null) {
                JSONObject jsonLoginUser = data.getJSONObject("loginuser");
                if (jsonLoginUser == null) {
                    data.put("srfmsg", "用户未登录");
                    return false;
                }
                // 组织信息存储
                wfinstance.setOriginpersonid(jsonLoginUser.getString("personId"));
                wfinstance.setOriginpersonname(jsonLoginUser.getString("orgUserName"));
                wfinstance.setOriginorgid(jsonLoginUser.getString("orgId"));
                wfinstance.setOriginorgname(jsonLoginUser.getString("orgName"));
                wfinstance.setOriginorgdeptid(jsonLoginUser.getString("orgDeptId"));
                wfinstance.setOriginorgdeptname(jsonLoginUser.getString("orgDeptName"));

                loginuserStr = jsonLoginUser.getString("personId");
            } else {
                // 组织信息存储
                wfinstance.setOriginpersonid(loginUser.getPersonId());
                wfinstance.setOriginpersonname(loginUser.getOrgUserName());
                wfinstance.setOriginorgid(loginUser.getOrgId());
                wfinstance.setOriginorgname(loginUser.getOrgName());
                wfinstance.setOriginorgdeptid(loginUser.getOrgDeptId());
                wfinstance.setOriginorgdeptname(loginUser.getOrgDeptName());

                loginuserStr = loginUser.getPersonId();
            }

        }
        wfinstance = uniWFFeignClient.createWFInstance(wfinstance);
        ${itemCodeNameLC}.set${de.getDefaultPSDEWF().getWFInstPSDEField().getCodeName()?cap_first}(wfinstance.getWfinstanceid());
        client.update(${itemCodeNameLC}${keyCNLC}, ${itemCodeNameLC});
        // 引擎创建实例

        // 获取工作流版本标识
        PSWFVersion wfVer = uniWFFeignClient.getPSWFVersion(wfinstance.getPswfversionid());

        // 业务数据
        String bsServiceStr = proxmoduleid + "Service";
        Class bsService = SpringContextHolder.getBean(bsServiceStr).getClass();
        Method bsServiceMethod = null;
        Object bsData = null;
        try {
            bsServiceMethod = bsService.getDeclaredMethod("get", String.class);
            bsData = bsServiceMethod.invoke(SpringContextHolder.getBean(bsServiceStr), proxydataid);
        } catch (Exception e) {
            e.printStackTrace();
            data.put("srfmsg", "获取业务数据异常");
            return false;
        }
        if (bsData == null) {
            System.err.println("业务数据为空");
            data.put("srfmsg", "业务数据为空");
            return false;
        }

        JSONObject bsJo = (JSONObject) JSONObject.toJSON(bsData);
        JSONObject params = new JSONObject();
        // 模拟用户
        params.put("srfuserid", loginuserStr);
        // 工作流引擎工作流标识
        params.put("srfdeployid", wfVer.getWfenginedeployid());
        // 业务数据
        params.put("srfbodata", bsJo);
        // 流程数据
        params.put("srfwfdata", ${itemCodeNameLC});
        // 实例数据标识
        params.put("srfwfinstanceid", wfinstance.getWfinstanceid());
        // 访问url
        params.put("srfviewurl", wfVer.getViewurl() + "?srfkey=" + ${itemPKParam} + ";srfappde=${de.getCodeName()};");
        // 意见签
        params.put("srfwfmemo", data.getString("srfwfmemo"));

        JSONObject rstObj = wfActivitiEngineFeignClient.wfStart(params);
        if (rstObj.getInteger("rst") == 0) {
            if (rstObj.getString("msg") != null) {
                System.err.println(rstObj.getString("msg"));
            }
            data.put("srfmsg", "引擎处理发生异常");
            return false;
        }
        return true;
    }

    /**
     * 流程处理【WFSubmit】
     */
    public boolean wfSubmit(${wfFuncParams}) {
        if (data == null ||
            data.getJSONObject("wfdata") == null || data.getJSONObject("opdata") == null ||
            data.getJSONObject("opdata").getString("srfwfiatag") == null || data.getJSONObject("opdata").getString("srfwfstep") == null) {
            System.err.println("传入参数缺失");
            data.put("srfmsg", "传入参数缺失");
            return false;
        }

        // 登录用户信息
        LoginUser loginUser = SpringContextHolder.getCurLoginUser();
        if (loginUser == null) {
            data.put("srfmsg", "用户未登录");
            return false;
        }

        // 流程数据
        JSONObject itemJo = data.getJSONObject("wfdata");
        ${itemCodeName} ${itemCodeNameLC} = itemJo.toJavaObject(${itemCodeName}.class);

        // 待办检查
        String wfworklistid = data.getString("worklistid");
        WFWorkList wfworklist = null;
        if (wfworklistid != null) {
            // 此块逻辑暂不开放
            // if (!testUserWFSubmit(wfworklistid, ${itemCodeNameLC}.get${de.getDefaultPSDEWF().getWFInstPSDEField().getCodeName()?cap_first}())) {
            //     data.put("srfmsg", "传入待办信息有误或已处理");
            //     return false;
            // }
            // wfworklist = uniWFFeignClient.getWFWorkList(wfworklistid);
            // 先使用此处逻辑 start
            wfworklist = this.getUserWorklist(${itemCodeNameLC}.get${de.getDefaultPSDEWF().getWFInstPSDEField().getCodeName()?cap_first}());
            if (wfworklist == null) {
                data.put("srfmsg", "当前用户无待办");
                return false;
            }
            // 先使用此处逻辑 end
        } else {
            wfworklist = this.getUserWorklist(${itemCodeNameLC}.get${de.getDefaultPSDEWF().getWFInstPSDEField().getCodeName()?cap_first}());
            if (wfworklist == null) {
                data.put("srfmsg", "当前用户无待办");
                return false;
            }
        }

        // 业务数据
        String bsServiceStr = ${itemCodeNameLC}.get${de.getDefaultPSDEWF().getProxyModulePSDEField().getCodeName()?cap_first}() + "Service";
        Class bsService = SpringContextHolder.getBean(bsServiceStr).getClass();
        Method bsServiceMethod = null;
        Object bsData = null;
        try {
            bsServiceMethod = bsService.getDeclaredMethod("get", String.class);
            bsData = bsServiceMethod.invoke(SpringContextHolder.getBean(bsServiceStr), ${itemCodeNameLC}.get${de.getDefaultPSDEWF().getProxyDataPSDEField().getCodeName()?cap_first}());
        } catch (Exception e) {
            e.printStackTrace();
            data.put("srfmsg", "获取业务数据异常");
            return false;
        }
        if (bsData == null) {
            System.err.println("业务数据为空");
            data.put("srfmsg", "业务数据为空");
            return false;
        }

        JSONObject bsJo = (JSONObject) JSONObject.toJSON(bsData);
        JSONObject params = new JSONObject();
        // 模拟用户
        params.put("srfuserid", loginUser.getPersonId());
        // 业务数据
        params.put("srfbodata", bsJo);
        // 流程数据
        params.put("srfwfdata", ${itemCodeNameLC});
        // 操作行为
        params.put("srfconnection", data.getJSONObject("opdata").getString("srfwfiatag"));
        // 流程实例标识
        params.put("srfwfinstanceid", wfworklist.getWfinstanceid());
        // 引擎工作列表标识
        params.put("srfwfengineworklistid", wfworklist.getWfengineworklistid());
        // 访问url
        <#if item.getPSAppWF().getPSAppWFVers()??>
            <#list item.getPSAppWF().getPSAppWFVers() as wfver>
        PSWFVersion wfVer = uniWFFeignClient.getPSWFVersion("${wfver.getPSWFVersion().getDeployId()}");
        params.put("srfviewurl", wfVer.getViewurl() + "?srfkey=" + ${itemPKParam} + ";srfappde=${de.getCodeName()};");
            <#break>
            </#list>
        </#if>
        // 意见签
        params.put("srfwfmemo", data.getString("srfwfmemo"));

        JSONObject rstObj = wfActivitiEngineFeignClient.wfSubmit(params);
        if (rstObj.getInteger("rst") == 0) {
            if (rstObj.getString("msg") != null) {
                System.err.println(rstObj.getString("msg"));
            }
            data.put("srfmsg", "引擎处理发生异常");
            return false;
        }
        return true;
    }

    /**
     * 测试当前用户是否提交过工作流【testUserWFSubmit】
     */
    public boolean testUserWFSubmit(${wfFuncParams}) {
        if (data == null || data.getJSONObject("wfdata") == null) {
            System.err.println("传入参数缺失");
            data.put("srfmsg", "传入参数缺失");
            return false;
        }
        String wfworklistid = data.getString("worklistid");
        // 流程数据
        JSONObject itemJo = data.getJSONObject("wfdata");
        ${itemCodeName} ${itemCodeNameLC} = itemJo.toJavaObject(${itemCodeName}.class);

        return testUserWFSubmit(wfworklistid, ${itemCodeNameLC}.get${de.getDefaultPSDEWF().getWFInstPSDEField().getCodeName()?cap_first}());
    }

    /**
     * 测试当前用户是否存在工作任务【testUserExistWorklist】
     */
    public boolean testUserExistWorklist(${wfFuncParams}) {
        if (data == null || data.getJSONObject("wfdata") == null) {
            System.err.println("传入参数缺失");
            data.put("srfmsg", "传入参数缺失");
            return false;
        }
        // 流程数据
        JSONObject itemJo = data.getJSONObject("wfdata");
        ${itemCodeName} ${itemCodeNameLC} = itemJo.toJavaObject(${itemCodeName}.class);
        WFWorkList curUserWorklist = this.getUserWorklist(${itemCodeNameLC}.get${de.getDefaultPSDEWF().getWFInstPSDEField().getCodeName()?cap_first}());
        return curUserWorklist != null;
    }

    /**
     * 测试当前用户是否提交过工作流
     */
    private boolean testUserWFSubmit(String worklistid, String wfinstanceid) {
        // 登录用户信息
        LoginUser loginUser = SpringContextHolder.getCurLoginUser();
        if (loginUser == null) {
            return false;
        }
        if (worklistid == null || wfinstanceid == null || worklistid.isEmpty() || wfinstanceid.isEmpty()) {
            return false;
        }
        // 实际从业务中获取
        JSONObject data = new JSONObject();
        data.put("worklistid", worklistid);
        data.put("wfinstanceid", wfinstanceid);
        data.put("userid", loginUser.getPersonId());
        return uniWFFeignClient.testUserWFSubmit(worklistid, data);
    }

    /**
     * 获取当前用户工作列表信息
     */
    private WFWorkList getUserWorklist(String wfinstanceid) {
        LoginUser loginUser = SpringContextHolder.getCurLoginUser();
        if (loginUser == null) {
            // 用户未登录
            return null;
        }
        JSONObject condition = new JSONObject();
        condition.put("page", 0);
        condition.put("size", 1);
        condition.put("n_wfuserid_eq", loginUser.getPersonId());
        condition.put("n_isclosed_noteq", 1);
        condition.put("n_wfinstanceid_eq", wfinstanceid);
        Page<WFWorkList> wfworklists = uniWFFeignClient.getWFWorkListByCondition(condition);
        if (wfworklists == null || wfworklists.getContent().size() == 0) {
            return null;
        }
        return wfworklists.getContent().get(0);
    }

    /**
     * 流程结束【WFClose】
     */
    public boolean wfClose(${wfFuncParams}) {
        if (data == null || data.getJSONObject("wfdata") == null) {
            System.err.println("传入参数缺失");
            data.put("srfmsg", "传入参数缺失");
            return false;
        }
        // 登录用户信息
        LoginUser loginUser = SpringContextHolder.getCurLoginUser();
        if (loginUser == null) {
            data.put("srfmsg", "用户未登录");
            return false;
        }

        // 流程数据
        JSONObject itemJo = data.getJSONObject("wfdata");
        ${itemCodeName} ${itemCodeNameLC} = itemJo.toJavaObject(${itemCodeName}.class);

        WFInstance wfinstance = uniWFFeignClient.getWFInstance(${itemCodeNameLC}.get${de.getDefaultPSDEWF().getWFInstPSDEField().getCodeName()?cap_first}());

        // 子流程实例检查
        JSONObject subInstCond = new JSONObject();
        subInstCond.put("page", 0);
        subInstCond.put("size", 1);
        subInstCond.put("n_parentinstid_eq", wfinstance.getWfinstanceid());
        subInstCond.put("n_isclosed_eq", 1);
        Page<WFInstance> subWfintances = uniWFFeignClient.getWFInstanceByCondition(subInstCond);
        if (subWfintances != null && subWfintances.getContent().size() > 0) {
            data.put("srfmsg", "当前实例存在子流程，请先关闭子流程");
            return false;
        }

         // 业务数据
        String bsServiceStr = ${itemCodeNameLC}.get${de.getDefaultPSDEWF().getProxyModulePSDEField().getCodeName()?cap_first}() + "Service";
        Class bsService = SpringContextHolder.getBean(bsServiceStr).getClass();
        Method bsServiceMethod = null;
        Object bsData = null;
        try {
            bsServiceMethod = bsService.getDeclaredMethod("get", String.class);
            bsData = bsServiceMethod.invoke(SpringContextHolder.getBean(bsServiceStr), ${itemCodeNameLC}.get${de.getDefaultPSDEWF().getProxyDataPSDEField().getCodeName()?cap_first}());
        } catch (Exception e) {
            e.printStackTrace();
            data.put("srfmsg", "获取业务数据异常");
            return false;
        }
        if (bsData == null) {
            System.err.println("业务数据为空");
            data.put("srfmsg", "业务数据为空");
            return false;
        }

        JSONObject bsJo = (JSONObject) JSONObject.toJSON(bsData);
        JSONObject params = new JSONObject();
        // 模拟用户
        params.put("srfuserid", loginUser.getPersonId());
        // 业务数据
        params.put("srfbodata", bsJo);
        // 流程数据
        params.put("srfwfdata", ${itemCodeNameLC});
        // 操作行为
        params.put("srfconnection", data.getJSONObject("opdata").getString("srfwfiatag"));
        // 流程实例标识
        params.put("srfwfinstanceid", wfinstance.getWfinstanceid());
        // 意见签
        params.put("srfwfmemo", data.getString("srfwfmemo"));

        JSONObject rstObj = wfActivitiEngineFeignClient.wfClose(params);
        if (rstObj.getInteger("rst") == 0) {
            if (rstObj.getString("msg") != null) {
                System.err.println(rstObj.getString("msg"));
            }
            data.put("srfmsg", "引擎处理发生异常");
            return false;
        }
        return true;
    }

    /**
     * 流程跳转【WFGoto】
     */
    public boolean wfGoto(${wfFuncParams}) {
        // 待实现
        return true;
    }

    /**
     * 流程重启【WFRestart】
     */
    public boolean wfRestart(${wfFuncParams}) {
        // 待实现
        return true;
    }

    /**
     * 流程撤回【WFRollback】
     */
    public boolean wfRollback(${wfFuncParams}) {
        // 待实现
        return true;
    }

    /**
     * 流程退回【WFSendBack】
     */
    public boolean wfSendBack(${wfFuncParams}) {
        // 待实现
        return true;
    }

    /**
     * 流程重新分配【WFReassign】
     */
    public boolean wfReassign(${wfFuncParams}) {
        // 待实现
        return true;
    }

    /**
     * 流程标记已读【WFMarkRead】
     */
    public boolean wfMarkRead(${wfFuncParams}) {
        if (data == null || data.getJSONObject("wfdata") == null) {
            System.err.println("传入参数缺失");
            data.put("srfmsg", "传入参数缺失");
            return false;
        }
        String wfworklistid = data.getString("worklistid");
        // 流程数据
        JSONObject itemJo = data.getJSONObject("wfdata");
        ${itemCodeName} ${itemCodeNameLC} = itemJo.toJavaObject(${itemCodeName}.class);
        String wfinstanceid = ${itemCodeNameLC}.get${de.getDefaultPSDEWF().getWFInstPSDEField().getCodeName()?cap_first}();

        if (wfworklistid == null || wfinstanceid == null || wfworklistid.isEmpty() || wfinstanceid.isEmpty()) {
            return false;
        }
        // 实际从业务中获取
        String userid = "systems";
        JSONObject data2 = new JSONObject();
        data2.put("worklistid", wfworklistid);
        data2.put("wfinstanceid", wfinstanceid);
        data2.put("userid", userid);
        return uniWFFeignClient.wfMarkRead(wfworklistid, data2);
    }

    /**
     * 流程业务数据行为【WFAction】
     */
    public JSONObject wfAction(${wfFuncParams}) {
        if (data == null
            || data.getString("type") == null
            || data.getString("wfinstanceid") == null) {
            System.err.println("传入参数缺失");
            data.put("rst", "0");
            data.put("msg", "传入参数缺失");
            return data;
        }
        String type = data.getString("type");
        String wfinstanceid = data.getString("wfinstanceid");
        String wfstep = data.getString("wfstep");

        // 流程实体
        ${itemCodeName} ${itemCodeNameLC} = this.get(${itemPKParam});

        WFInstance wfinstance = this.uniWFFeignClient.getWFInstance(wfinstanceid);
        if (wfinstance == null) {
            System.err.println("查询不到流程实例");
            data.put("rst", "0");
            data.put("msg", "查询不到流程实例");
            return data;
        }
        JSONObject psdewfCond = new JSONObject();
        psdewfCond.put("n_psworkflowid_eq", wfinstance.getPsworkflowid());
        psdewfCond.put("n_psdataentityid_eq", "${de.getDeployId()}");
        Page<PSDEWF> psdewfs = this.uniWFFeignClient.getPSDEWFByCondition(psdewfCond);
        if (psdewfs == null || psdewfs.getContent().size() == 0) {
            data.put("rst", "0");
            data.put("msg", "未查到流程实体");
            return data;
        }
        PSDEWF psdewf = psdewfs.getContent().get(0);

         // 业务状态
        String status = null;
        if ("start".equals(type)) {
            status = psdewf.getProcessvalue();
        } else if ("gotostep".equals(type)) {
            status = psdewf.getProcessvalue();
        } else if ("finish".equals(type)) {
            status = psdewf.getFinishvalue();
        } else if ("cancel".equals(type)) {

        } else if ("error".equals(type)) {
            status = psdewf.getErrorvalue();
        }

        // 保存当前数据
        if (status != null && !status.isEmpty()) {
    <#if de.getDefaultPSDEWF().getWFStatePSDEField()??>
            ${itemCodeNameLC}.set${de.getDefaultPSDEWF().getWFStatePSDEField().getCodeName()?cap_first}(<#if srfjavatype(de.getDefaultPSDEWF().getWFStatePSDEField().getStdDataType()) == "Integer">Integer.parseInt(status)<#else>status</#if>);
    </#if>
    <#if de.getDefaultPSDEWF().getUDStatePSDEField()??>
            ${itemCodeNameLC}.set${de.getDefaultPSDEWF().getUDStatePSDEField().getCodeName()?cap_first}(<#if srfjavatype(de.getDefaultPSDEWF().getUDStatePSDEField().getStdDataType()) == "Integer">Integer.parseInt(status)<#else>status</#if>);
    </#if>
        }
        if (wfstep != null && !wfstep.isEmpty()) {
    <#if de.getDefaultPSDEWF().getWFStepPSDEField()??>
            ${itemCodeNameLC}.set${de.getDefaultPSDEWF().getWFStepPSDEField().getCodeName()?cap_first}(<#if srfjavatype(de.getDefaultPSDEWF().getWFStepPSDEField().getStdDataType()) == "Integer">Integer.parseInt(wfstep)<#else>wfstep</#if>);
    </#if>
        }

        // 保存业务数据
        this.update(${itemPKParam}, ${itemCodeNameLC});

        data.put("rst", "1");
        return data;
    }

    /**
     * 获取代理数据【WFGetProxyData】
     */
    public JSONObject wfGetProxyData(${wfFuncParams2}) {
        JSONObject data = new JSONObject();
        String proxyviewurl = uniWFFeignClient.wfGetProxyData(${itemPKParam});
        data.put("proxyviewurl", proxyviewurl);
        return data;
    }

</#if>
<#if isClientWFDE>
	public JSONObject wfStart(${wfFuncParams2}) {
	    PSDataEntity psdataentity = new PSDataEntity();
        psdataentity.setPsdataentityid("${de.getDeployId()}");
        psdataentity.setWorkflowid(sysInfoProperties.getDomainid());
        psdataentity.setPssystemid(sysInfoProperties.getSystemid());
        String uniwfUrl = "http://localhost:8111/";
        if (uniWFClientProperties.getAppUrl() != null && !uniWFClientProperties.getAppUrl().isEmpty()) {
            uniwfUrl = uniWFClientProperties.getAppUrl();
        }
    	JSONObject json = new JSONObject();
    	json.put("url", uniwfUrl
                        + "#/selectindexview/null/pswfversions/null/dataview?customParams=dataentityid:"
                        + psdataentity.getPsdataentityid() + ","
                        + "proxydataid:" + ${itemPKParam} + ","
                        + "proxymoduleid:${de.getCodeName()}"
    			);

        return json;
    }

    /**
     * 流程业务数据行为【WFAction】
     */
    public JSONObject wfAction(${wfFuncParams}) {
        if (data == null
            || data.getString("type") == null
            || data.getString("wfinstanceid") == null) {
            System.err.println("传入参数缺失");
            data.put("rst", "0");
            data.put("msg", "传入参数缺失");
            return data;
        }
        String type = data.getString("type");
        String wfinstanceid = data.getString("wfinstanceid");
        String wfstep = data.getString("wfstep");

        // 业务实体
        ${itemCodeName} ${itemCodeNameLC} = this.get(${itemPKParam});

        WFInstance wfinstance = this.uniWFFeignClient.getWFInstance(wfinstanceid);
        if (wfinstance == null) {
            System.err.println("查询不到流程实例");
            data.put("rst", "0");
            data.put("msg", "查询不到流程实例");
            return data;
        }
        JSONObject psdewfCond = new JSONObject();
        psdewfCond.put("n_psworkflowid_eq", wfinstance.getPsworkflowid());
        psdewfCond.put("n_psdataentityid_eq", "${de.getDeployId()}");
        Page<PSDEWF> psdewfs = this.uniWFFeignClient.getPSDEWFByCondition(psdewfCond);
        if (psdewfs == null || psdewfs.getContent().size() == 0) {
            data.put("rst", "0");
            data.put("msg", "未查到流程实体");
            return data;
        }
        PSDEWF psdewf = psdewfs.getContent().get(0);

         // 业务状态
        String status = null;
        if ("start".equals(type)) {
            status = psdewf.getProcessvalue();
        } else if ("gotostep".equals(type)) {
            status = psdewf.getProcessvalue();
        } else if ("finish".equals(type)) {
            status = psdewf.getFinishvalue();
        } else if ("cancel".equals(type)) {

        } else if ("error".equals(type)) {
            status = psdewf.getErrorvalue();
        }

        // 保存当前数据
        if (status != null && !status.isEmpty()) {
    <#if de.getDefaultPSDEWF().getWFStatePSDEField()??>
            ${itemCodeNameLC}.set${de.getDefaultPSDEWF().getWFStatePSDEField().getCodeName()?cap_first}(<#if srfjavatype(de.getDefaultPSDEWF().getWFStatePSDEField().getStdDataType()) == "Integer">Integer.parseInt(status)<#else>status</#if>);
    </#if>
    <#if de.getDefaultPSDEWF().getUDStatePSDEField()??>
            ${itemCodeNameLC}.set${de.getDefaultPSDEWF().getUDStatePSDEField().getCodeName()?cap_first}(<#if srfjavatype(de.getDefaultPSDEWF().getUDStatePSDEField().getStdDataType()) == "Integer">Integer.parseInt(status)<#else>status</#if>);
    </#if>
        }
        if (wfstep != null && !wfstep.isEmpty()) {
    <#if de.getDefaultPSDEWF().getWFStepPSDEField()??>
            ${itemCodeNameLC}.set${de.getDefaultPSDEWF().getWFStepPSDEField().getCodeName()?cap_first}(<#if srfjavatype(de.getDefaultPSDEWF().getWFStepPSDEField().getStdDataType()) == "Integer">Integer.parseInt(wfstep)<#else>wfstep</#if>);
    </#if>
        }

        // 保存业务数据
        this.update(${itemPKParam}, ${itemCodeNameLC});

        data.put("rst", "1");
        return data;
    }
</#if>
}
